#! /usr/bin/python

#-*- coding:UTF-8 -*-

import os
import sys
import tempfile
import shutil
import ConfigParser
import time
import zipfile 

# show solution list, mostly, select common is ok.
def ShowPackList():
	path= sys.path[0] + "\\pack_template";
	files = os.listdir(path);
	for index in range(len(files)):
		print str(index), ":", files[index];
		files[index] = path + "\\" + files[index]; 
	return files;

	
def CopySolutionFilesToWorkingDirectory(solutiondir, workdirectory):
	print("copy solution files:[" + solutiondir + "]to[" + workdirectory + "]");
	allfiles = os.listdir(solutiondir);
	for file in allfiles:
		fullpath = solutiondir + file;
		if os.path.isdir(fullpath):
			CopyFilesToDirectory(fullpath, workdirectory);
		else:
			shutil.copyfile(fullpath, workdirectory + file);
	
def CopyFilesToDirectory(src, dest):
	allfiles = os.listdir(src);
	for file in allfiles:
		fullpath = src + file;
		if file == "pack_template":
			continue;
		if os.path.isdir(fullpath):
			os.mkdir(dest + file);
			CopyFilesToDirectory(fullpath + "\\", dest + file + "\\");
		else:
			print("copy release files:[" + fullpath + "]to[" + dest + file + "]");
			shutil.copyfile(fullpath, dest + file);
	
	
def DeleteUnusedFiles(dirpath):
	files = os.listdir(dirpath);
	for filename in files:
		if len(filter(filename.endswith, [".lib", ".exp", ".pdb", ".py", ".zip"])):
			print("delete file:" + filename);
			os.unlink(dirpath + filename);
	
	tmpfile = dirpath + "DragonKeySdkDemo.exe";
	if os.path.isfile(tmpfile):
		os.unlink(tmpfile);
	
	
def DeleteRecordLog(dirpath):
	shutil.rmtree(dirpath + "RecordAlone");
	shutil.rmtree(dirpath + "Record");

def Zip(src, dest):
	tar = zipfile.ZipFile(dest, "w", zipfile.zlib.DEFLATED);
	for root, dir, files in os.walk(src):
		for file in files:
			filepath = os.path.join(root, file);
			
			tar.write(filepath, filepath[len(src):]);

	
def main(argc, argv):
	if argc == 1:
		print "packing for common version tool\n";
	else:
		print "packing for ", sys.argv[1], "solution\n";
	
	# select solution
	solutions = ShowPackList();
	select = int(raw_input("select pack solution:"));
	if (select in range(len(solutions))):
		print("packing for " + os.path.basename(solutions[select]) + " solution\n");
		tmpdirpath = tempfile.mktemp() + "\\";
		os.mkdir(tmpdirpath);
		print "working in directory:", tmpdirpath;
		# copy files to tmp directory
		CopyFilesToDirectory(sys.path[0] + "\\", tmpdirpath);
		CopySolutionFilesToWorkingDirectory(solutions[select] + "\\", tmpdirpath);
		DeleteUnusedFiles(tmpdirpath);
		DeleteRecordLog(tmpdirpath);
		
		#create zip file
		strZip = "DragonSN_" + time.strftime("%Y_%m_%d_%H_%M_%S", time.localtime()) + ".zip";
		Zip(tmpdirpath, sys.path[0] + "\\" + strZip);
		
		
	
	
if __name__ == '__main__':
    main(len(sys.argv), sys.argv);
